import torch
import numpy as np
from torch.utils.data import Dataset, DataLoader


class SequenceDataset(Dataset):

    def __init__(self, data, labels):
        self.data = torch.from_numpy(data).float()
        self.labels = torch.tensor(labels).float()

    def __len__(self):
        return len(self.data)

    def __getitem__(self, idx):
        # Return data (seq_len, batch, input_dim), label for index
        return (self.data[idx], self.labels[idx])

    

def random_shuffle(arr):
    x, y, z = arr.shape
    print(z, y, z)
    rows = np.indices((x,y))[0]
    cols = [np.random.permutation(y) for _ in range(x)]
    return arr[rows, cols, :]    