import torch
import numpy as np
from sklearn import metrics

def pred_from_raw(raw):   
    pred = torch.zeros(raw.shape[0])
    pred[raw>0.5] = 1
    return pred


def all_metrics(raw, y_true, avg):
    pred = pred_from_raw(raw)
    acc =  metrics.accuracy_score(pred, y_true.numpy())
    f1 = metrics.f1_score(pred, y_true.numpy())
    prec = metrics.precision_score(pred, y_true.numpy())
    rec = metrics.recall_score(pred, y_true.numpy())
    return acc, f1, prec, rec, pred


class Metrics():

    def __init__(self):
        self.metrics = {'prec': 0, 'recall': 0, 'f1': 0, 'acc': 0, 'loss': 0}
       
    def get_metrics(self, raw, y_true, avg=None):
        acc, f1, prec, recall, pred = all_metrics(raw, y_true, avg)        
        self.metrics = {'prec': prec, 'recall': recall, 'f1': f1, 'acc': acc}
        return self.metrics, pred